
 * @Author       : yuanrunwei
 * @Date         : 2021-12-04 14:23:58
 * @LastEditors: daiqisheng
 * @LastEditTime: 2022-04-25 19:11:41
 * @FilePath     : \spfm-market-front\src\pages\main\performance\components\sheet.vue
-->
<template>
  <div class="sheet-container">
    <div style="margin: 20px 0 40px 0; display: flex">
      运营商：
      <el-select v-model="bednumber" @change="getCheck()">
        <el-option
          v-for="(item, index) in options"
          :key="index"
          :label="item.value"
          :value="item.value"
        ></el-option>
      </el-select>
      <el-button type="primary" @click="handleResave" 
        >保存</el-button
      >
      <!-- <el-upload
        class="upload-demo"
        multiple
        ref="upload"
        action="string"
        :http-request="clickok"
        :before-upload="deforeUp"
        :on-change="handleChange"
      >
        <div>
          <i class="el-icon-upload"></i>
          <div class="el-upload__text">点击上传</div>
        </div>
        <div>
          <el-button>123</el-button>
        </div>
      </el-upload> -->
      <el-button type="primary" @click="handleDownload">导出</el-button>
      <el-button type="primary" @click="handleFullscreen()">全屏显示</el-button>
    </div>

    <div id="luckysheet" style="width: 75%; height: 70%"></div>
  </div>
</template>

<script>
import luckyexcel from "luckyexcel";

import { exportExcel } from "./components//export.js";

// import simpleDialog from "./dialog.vue";z
export default {
  components: {
    // simpleDialog,
  },
  props: {
    type: {
      type: String,
      default: "view", // view 查看 edit 编辑
    },
    attribute: {
      type: String,
      default: "template", // template 模板 order 工单 file 文件
    },
    id: {
      default: null,
    },
    // 接收人
    receiver: {
      type: String,
      default: "",
    },
    // 模板状态按钮判断
    status: { type: String, default: "" },
  },

  data() {
    return {
      bednumber: "联通",
      checkStatus: false,
      unicomList: [], //联通excelList
      telecomList: [], //电信excelList
      options: [
        {
          value: "电信",
        },
        {
          value: "联通",
        },
      ],
      dialogTableVisible: true,
      celldata: [
        { r: 0, c: 0, v: { v: "运营商", bl: 1, ht: 0, vt: 0 } },
        {
          r: 0,
          c: 1,
          tb: 2,
          v: {
            tb: 2,
            fs: 11,
            ht: 0,
            vt: 0,
            v: "套餐档位（从低到高进行填写）低档：58元以下套餐中档：58元（含）-128元套餐（不含）高档：128元及以上套餐",
            ct: { fa: "General", t: "n" },
            m: "2",
          },
        },
        {
          r: 0,
          c: 2,
          v: {
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
            v: "套餐名称",
            ct: { fa: "General", t: "n" },
            m: "3",
          },
        },
        {
          r: 0,
          c: 3,
          v: {
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
            v: "是否为主推套餐",
            ct: { fa: "General", t: "n" },
            m: "0",
          },
        },
        {
          r: 0,
          c: 4,
          v: {
            v: "月费(元)",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
        {
          r: 0,
          c: 5,
          v: {
            v: "优惠价",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
        {
          r: 0,
          c: 6,
          v: {
            v: "预存款(元)",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
        {
          r: 0,
          c: 7,
          v: {
            v: "套餐内容",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
        {
          r: 0,
          c: 8,
          v: {
            v: "酬金",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
        {
          r: 0,
          c: 9,
          v: {
            v: "在售区域",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
        {
          r: 0,
          c: 10,
          v: {
            v: "在售渠道",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
        {
          r: 0,
          c: 11,
          v: {
            v: "月销量",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
        {
          r: 0,
          c: 12,
          v: {
            v: "是否包含宽带",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
        {
          r: 0,
          c: 13,
          v: {
            v: "宽带具体内容",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
        {
          r: 0,
          c: 14,
          v: {
            v: "是否包括电视",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
        {
          r: 0,
          c: 15,
          v: {
            v: "是否包括副卡",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
        {
          r: 0,
          c: 16,
          v: {
            v: "是否包括亲情网",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
        {
          r: 0,
          c: 17,
          v: {
            v: "是否包括v网产品",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
        {
          r: 0,
          c: 18,
          v: {
            v: "其他补充信息",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
        {
          r: 0,
          c: 19,
          v: {
            v: "上报人",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
        {
          r: 0,
          c: 20,
          v: {
            v: "联系电话",
            bl: 0,
            it: 0,
            ff: 0,
            fs: 11,
            fc: "rgb(51, 51, 51)",
            ht: 0,
            vt: 0,
          },
        },
      ],
      form: {
        charge: [
          {
            person: [],
            col_start: "",
            col_end: "",
            row_start: "",
            row_end: "",
          },
        ],
        array: [],
        type: null,
        permission_type: null,
        col_start: "",
        col_end: "",
        row_start: "",
        row_end: "",
      },
      approveForm: {
        type: "",
        comments: "",
        list: [
          {
            label: "同意",
            value: "同意",
          },
          {
            label: "不同意",
            value: "不同意",
          },
          {
            label: "其他",
            value: "3",
          },
        ],
      },
      superviserules: {
        distribute: [
          { required: true, message: "请选择派发周期", trigger: "change" },
        ],
        write: [
          { required: true, message: "请选择填报周期", trigger: "change" },
        ],
        endTime: [
          { required: true, message: "请选择截止时间", trigger: "change" },
        ],
      },
      superviseForm: {
        distribute: "", // 派单周期
        write: "", // 填写周期
        endTime: "", // 截止时间
      },
      originSuperviseForm: {},
      pickOptions: {
        disabledDate(time) {
          return time.getTime() < new Date().getTime() - 8.64e7;
        },
      },
      pickWrite: {
        disabledDate(time) {
          return time.getTime() < new Date().getTime() - 8.64e7;
        },
      },
      // 可提交标志
      addFlag: "0",
      // 督办标志
      superviseFlag: null,
      rowList: [],
      isDisable: true,
      issued_id: null,
      template_id: null,
      visible: false,
      templateType: "",
      // 督办
      supervise: false,
      manager_approve: false,
      row_list: [],
      column_list: [],
      charge_list: [],
      a: [],
      b: [],
      type_options: [
        {
          value: 1,
          label: "按行",
        },
        // {
        //     value: 2,
        //     label: "按列",
        // },
      ],
    };
  },
  // watch: {
  //    bednumber(newVal,oldVal){
  //     console.log(newVal,oldVal);
  //    },
  //  deep:true,
  //  immediate:true
  //
  //   },
  //  created(){
  //    console.log('123123123123');
  //  },
  methods: {
    async getCheck() {
      if (this.bednumber === "联通") {
        Promise.all([await this.getUnicom(), await this.getUnicomList()]).then(
          (res) => {
            this.handleCreate(this.a);
          }
        );
      } else {
        Promise.all([await this.getMove(), await this.getMoveList()]).then(
          (res) => {
            this.handleCreate(this.b);
          }
        );
      }
    },
    async getUnicom() {
      await this.$http({
        url: "/market/expensesUnicom/loadProv",
        method: "post",
        headers: {
          "Content-Type": "application/json",
        },
      }).then((res) => {
        // this.handleCreate(res.data.body)
         res.data.body[0].index= 0
        res.data.body[0].subScript = 0;
        this.a = res.data.body;
      });
    },
    async getUnicomList() {
      await this.$http({
        url: "/market/questionnaireUnicom/loadProv",
        method: "post",
        headers: {
          "Content-Type": "application/json",
        },
      }).then((res) => {
         res.data.body[0].index= 1
        res.data.body[0].subScript = 1;
        this.a.push(res.data.body[0]);
      });
    },
    async getMove() {
      await this.$http({
        url: "/market/expensesTelecom/loadProv",
        method: "post",
        headers: {
          "Content-Type": "application/json",
        },
      }).then((res) => {
         res.data.body[0].index= 0
        res.data.body[0].subScript = 2;
        this.b = res.data.body;
      });
    },
    async getMoveList() {
      await this.$http({
        url: "/market/questionnaireTelecom/loadProv",
        method: "post",
        headers: {
          "Content-Type": "application/json",
        },
      }).then((res) => {
         res.data.body[0].index= 1
        res.data.body[0].subScript = 3;
        this.b.push(res.data.body[0]);
      });
    },

    //获取用户是否为外呼调研员
    async getJurisdiction() {
      await this.$http({
        url: "/market/questionnaireUnicom/queryRole",
        method: "post",
        headers: {
          "Content-Type": "application/json",
        },
      }).then((res) => {
            if(res.data.body === '0'){ //是外呼管理员
          this.clickOut = true //显示导出
          this.clickSave = false //不显示保存
        }else{
          this.clickOut = false //显示导出
          this.clickSave = true //不显示保存
        }
       
        console.log(res.body);
      });
    },
    // handleChange(file, fileList) {
    //     console.log(file);
    //     this.fileList = fileList.slice(-3);
    // },
    clickok() {},
    deforeUp(file) {
      console.log(file);
    },
    handleInit() {
      if (this.id) {
        this.handleQuery();
      } else {
        this.handleCreate();
      }
    },
    // 填报日期
    handleWrite(value) {
      if (value) {
        let range =
          new Date().getTime() > value.getTime()
            ? new Date().getTime()
            : value.getTime();
        this.pickOptions = {
          disabledDate(time) {
            return time.getTime() < range;
          },
        };
      } else {
        this.pickOptions = {
          disabledDate(time) {
            return time.getTime() < new Date().getTime() - 864000;
          },
        };
      }
    },
    handleEnd(value) {
      if (value) {
        this.pickWrite = {
          disabledDate(time) {
            return time.getTime() > value.getTime();
          },
        };
        if (
          this.superviseForm.write &&
          value.getTime() < this.superviseForm.write.getTime()
        ) {
          this.superviseForm.endTime = "";
        }
      } else {
        this.pickWrite = {
          disabledDate(time) {
            return time.getTime() - 864000 < new Date().getTime();
          },
        };
      }
    },
    // // 权限选择
    // handleRadio(e){
    //     console.log(e,'e');
    // },
    handleAllow({ row, column }) {
      let public_permisson =
        (!this.form.permission_type ||
          this.status === "2" ||
          this.status === "3") &&
        this.type === "edit";
      let editable =
        this.row_list.includes(row) && this.column_list.includes(column);
      // let totalBoolean = (public_permisson || editable) && this.id;
      let totalBoolean = public_permisson || editable;
      return totalBoolean;
    },
    async handleQuery() {
      let url = "";
      let params = {};
      switch (this.attribute) {
        case "template":
          url = "/market/CMKFileTemplate/QueryCMKFileTemplateById";
          params = {
            templateId: this.id,
          };
          break;
        case "order":
          url = "/market/CMKIssued/CMKQueryIssuedById";
          params = {
            id: this.id,
          };
          break;
        case "file":
          url = "/market/CMKIssued/CMKIssuedProcessByUser";
          params = {
            id: this.id,
            receiverId: this.receiver,
          };
          break;
      }
      const {
        data: {
          templateContent,
          templateName,
          issuedId,
          templateId,
          list,
          superviseFlag,
          templateType,
          addFlag,
          distributeEndTime,
          distributeTime,
          distributeType,
        },
      } = await this.$http({
        url,
        method: "post",
        headers: {
          "Content-Type": "application/json",
        },
        data: params,
      });
      this.superviseFlag = superviseFlag;
      if (superviseFlag === "1") {
        this.superviseForm = {
          distribute: distributeType, // 派单周期
          write: distributeTime, // 填写周期
          endTime: distributeEndTime, // 截止时间
        };
      }
      this.templateType = templateType;
      this.template_id = templateId;
      this.issued_id = issuedId;
      this.addFlag = addFlag;
      console.log(JSON.parse(templateContent), "123123");
      if (list && list.length) {
        const { type } = list[0];
        if (type === "1") {
          // 公共权限
          // const { allowEditingColumns, rowNum } = list[0];
          this.form = {
            permission_type: Number(type) - 1,
            person: list.map((el) => {
              return `${el.principalMent}-${el.principalId},${el.principalName}`;
            }),
            charge: [
              {
                person: "",
                col_start: "",
                col_end: "",
                row_start: "",
                row_end: "",
              },
            ],
          };
        } else {
          // 特殊权限
          this.form = {
            permission_type: Number(type) - 1,
            col_start: "",
            col_end: "",
            row_start: "",
            row_end: "",
            charge: list.map((el) => ({
              person: `${el.principalMent}-${el.principalId},${el.principalName}`,
              col_start: el.allowEditingColumns.split(",")[0],
              col_end:
                el.allowEditingColumns.split(",")[
                  el.allowEditingColumns.split(",").length - 1
                ],
              row_start: el.rowNum.split(",")[0],
              row_end: el.rowNum.split(",")[el.rowNum.split(",").length - 1],
            })),
          };
        }
        this.row_list =
          this.type === "edit" && list[0].rowNum
            ? list[0].rowNum
                .split(",")
                .map((element) => JSON.parse(element) - 1)
            : [];
        if (this.type === "edit" && list[0].allowEditingColumns) {
          // this.column_list = list[0].allowEditingColumns
          //   .split(",")
          //   .map((element) => JSON.parse(element) - 1);
          this.column_list =
            list[0].allowEditingColumnsFlag === "1"
              ? list[0].allowEditingColumnsShuzi
                  .split(",")
                  .map((element) => JSON.parse(element) - 1)
              : list[0].allowEditingColumns
                  .split(",")
                  .map((element) => JSON.parse(element) - 1);
        } else {
          this.column_list = [];
        }
        // this.formateNumber(list[0].allowEditingColumns);
      }
      this.handleCreate({
        json: templateContent ? JSON.parse(templateContent) : {},
        name: templateName,
        type: "json",
      });
    },
    handleSupervise(data) {
      if (data === "cancel") {
        this.supervise = false;
        this.superviseForm = {
          ...this.originSuperviseForm,
        };
        return;
      }
      if (this.supervise === false) {
        this.supervise = true;
        this.originSuperviseForm = {
          ...this.superviseForm,
        };
      } else {
        let filled =
          Object.keys(this.superviseForm).length === 3 &&
          Object.values(this.superviseForm).filter((el) => el !== "").length ===
            3;
        if (filled) {
          let time = new Date().getTime();
          if (time > this.superviseForm.endTime.getTime()) {
            this.$message.error("截止时间不能小于当前时间");
            return;
          }
          this.superviseForm = {
            ...this.superviseForm,
            endTime: this.$formatDate(
              this.superviseForm.endTime,
              "YYYY-MM-DD HH:mm:ss"
            ), // 督办设置的截止时间
            write: this.$formatDate(this.superviseForm.write, "YYYY-MM-DD"), // 派发时间–或者叫—填报时间
          };
          this.supervise = false;
        } else {
          this.$message.error("请填写完整必要的信息");
        }
      }
    },
    handleForbid() {
      // const object = {};
      const { permission_type } = this.form;
      if (permission_type === 0) {
        // 公共权限 暂时不用可编辑行和列
        const { person } = this.form;
        if (person.length) {
          return false;
        }
        return true;
      } else if (permission_type === 1) {
        // 特殊权限
        let flag = 1;
        const { charge } = this.form;
        charge.forEach((el) => {
          if (
            Object.values(el).filter((v) => {
              return v !== "";
            }).length === 5
          ) {
            flag = flag * 1;
          } else {
            flag = flag * 0;
          }
        });
        return !flag;
      } else {
        return true;
      }
    },
    async handleCreate(data) {
      console.log(data);
      let that = this;
      const options = {
        container: "luckysheet",
        lang: "zh",
        total: "123",
        showsheetbar: true,
        hook: {
          // cellEditBefore: function () {
          //   let time = new Date();
          //   let hover = time.getHours();
          //   let day = time.getDay();
          //   if (day === 4 || day === 5 || day === 6 || day == 7 || day === 1) {
          //     if ((day === 4 && hover <= 15) || (day === 1 && hover >= 15)) {
          //       that.$message.error("不在可编辑时间");
          //       return false;
          //     }
          //   } else {
          //     that.$message.error("不在可编辑日期");
          //     return false;
          //   }
          // },
        },
        data: data,
        // hook: {
        //   cellEditBefore: function ([
        //     { row_focus: row, column_focus: column },
        //   ]) {
        //     if (!that.handleAllow({ row, column })) {
        //       that.$message.error("您没有编辑权限");
        //     }
        //   },
        //   // cellUpdated: function (row, column) {
        //   //   that.rowList.push(row);
        //   // },
        //   cellUpdateBefore: function (row, column) {
        //     console.log(row, column);
        //     if (!that.handleAllow({ row, column })) {
        //       return false;
        //     }
        //   },
        //   cellRenderAfter: function (cell, position) {
        //     const { r: row, c: column } = position;
        //     console.log();
        //     if (cell) {
        //       if (!that.handleAllow({ row, column })) {
        //         cell.bg = "#d5d5d5";
        //       } else {
        //         cell.bg = "#ffffff";
        //       }
        //     }
        //   },
        //   rangePasteBefore: function ([
        //     { row_focus: row, column_focus: column },
        //   ]) {
        //     if (!that.handleAllow({ row, column })) {
        //       that.$message.error("您没有编辑权限");
        //       return false;
        //     }
        //   },
        //   updated: function ({ range }) {
        //     const middle = range.map((el) => {
        //       return that.paramsArr(el.row[0], el.row[1]);
        //     });
        //     let changedList = middle.join(",").split(",");
        //     that.rowList.push(...changedList);
        //   },
        // },
      };

      // switch (data.type) {
      //   case "file":
      //     if (data.file) {
      //       await new Promise((resolve) => {
      //         luckyexcel.transformExcelToLucky(data.file, (export_json) => {
      //           options.data = [
      //             ...export_json.sheets.map((element) => ({
      //               ...element,
      //               zoomRatio: 0.75,
      //             })),
      //           ];
      //           options.title = export_json.info.name;
      //           resolve();
      //         });
      //       });
      //     }
      //     break;
      //   case "json":
      //     console.log(123);
      //     // if (json) {
      //     //   options.data = [];
      //     //   options.title = name;
      //     // }
      //     break;
      // }
      window.luckysheet.create(options);

      let clock = setInterval(() => {
        if (window.luckysheet) {
          window.luckysheet.refresh();
          clearInterval(clock);
        }
      }, 1000);
    },
    async handleChange(response) {
      response.raw.total = "123";
      console.log(response);
      this.handleCreate({ file: response.raw, type: "file" });
    },
    //导出方法！！！！！
    async handleDownload() {
      Promise.all([
        await this.getMove(),
        await this.getMoveList(),
        await this.getUnicom(),
        await this.getUnicomList(),
      ]).then((res) => {
        let list = this.a.concat(this.b);
        exportExcel(list, "导出问卷");
      });
    },
    async handleAddAuth({ id }) {
      // const object = {};
      const { permission_type } = this.form;
      console.log(id, permission_type);
      let reqdata = {
        templateId: id,
        type: permission_type ? 2 : 1,
      };
      if (!permission_type) {
        //  公共权限
        const { person } = this.form;

        const principalId = [];
        const principalName = [];
        const principalMent = [];
        person.forEach((el) => {
          principalMent.push(el.split(",")[0].split("-")[0]);
          principalId.push(el.split(",")[0].split("-")[1]);
          principalName.push(el.split(",")[1]);
        });
        reqdata.principalId = principalId.join(",");
        reqdata.principalName = principalName.join(",");
        reqdata.principalMent = principalMent.join(",");
      } else {
        const { charge } = this.form;
        //  特殊权限
        reqdata.specialAuth = charge.map((el) =>
          JSON.stringify({
            allowEditingColumns: `${el.col_start},${el.col_end}`,
            rowNum: `${el.row_start},${el.row_end}`,
            principalMent: el.person.split(",")[0].split("-")[0],
            principalId: el.person.split(",")[0].split("-")[1],
            principalName: el.person.split(",")[1],
          })
        );
      }
      const {
        data: { result, desc },
      } = await this.$http({
        url: this.id
          ? "/market/CMKFileTemplateAuthority/CMKFileTemplateAuthorityUpdate"
          : "/market/CMKFileTemplateAuthority/CMKFileTemplateAuthorityAdd",
        method: "post",
        headers: {
          "Content-Type": "application/json",
        },
        data: reqdata,
      });
      if (result) {
        this.$message.error(desc);
      } else {
        this.$message.success(desc);
      }
      return result;
    },
    async handleSave(type) {
      let edit_url = "";
      switch (this.attribute) {
        case "template":
          edit_url = "";
          break;
        case "order":
          edit_url = "";
          break;
        case "file":
          edit_url = "/market/CMKIssued/CMKIssuedSubmit";
          break;
      }

      const sheet_name = window.luckysheet.getSheet().name;
      const data = window.luckysheet.getSheet(sheet_name);
      const workbook_name = window.luckysheet.getWorkbookName();
      if (!this.id) {
        // 新增时添加权限
        let value = {};
        if (!this.templateType) {
          this.$message.error("请输入模板类型");
          return;
        }
        if (
          Object.values(this.superviseForm).filter((el) => el !== "").length ===
          3
        ) {
          value = {
            distributeEndTime: this.superviseForm.endTime, // 督办设置的截止时间
            distributeTime: this.superviseForm.write, // 派发时间–或者叫—填报时间
            distributeType: this.superviseForm.distribute, //派发周期类型 派发周期类型 0.月 1.季度 2.半年 3.年
            superviseFlag: 1, //督办标识 0.不是 1.是
            templateType: this.templateType, //模板类型
            templateContent: JSON.stringify(data), //文件内容
            templateName: workbook_name, //模板名称
            templateUrl: "", //文件链接
            status: type,
          };
        } else {
          value = {
            superviseFlag: 0, //督办标识 0.不是 1.是
            templateType: this.templateType, //模板类型
            templateContent: JSON.stringify(data), //文件内容
            templateName: workbook_name, //模板名称
            templateUrl: "", //文件链接
            status: type,
          };
        }
        const {
          data: { body },
        } = await this.$http({
          url: "/market/CMKFileTemplate/CMKFileTemplateAdd", // 新增
          method: "post",
          headers: {
            "Content-Type": "application/json",
          },
          data: value,
        });
        await this.handleAddAuth({ id: body });
        this.$emit("save");
      } else {
        // 职位
        let duty = JSON.parse(sessionStorage.userInfo).duty;
        if (duty === "7" && type === "0") {
          this.manager_approve = true;
        } else {
          if (type === "2") {
            // 暂存
            let value = {};
            if (!this.templateType) {
              this.$message.error("请输入模板类型");
              return;
            }
            if (
              Object.values(this.superviseForm).filter((el) => el !== "")
                .length === 3
            ) {
              value = {
                templateId: this.id,
                distributeEndTime: this.superviseForm.endTime, // 督办设置的截止时间
                distributeTime: this.superviseForm.write, // 派发时间–或者叫—填报时间
                distributeType: this.superviseForm.distribute, //派发周期类型 派发周期类型 0.月 1.季度 2.半年 3.年
                superviseFlag: 1, //督办标识 0.不是 1.是
                templateType: this.templateType, //模板类型
                templateContent: JSON.stringify(data), //文件内容
                templateName: workbook_name, //模板名称
                templateUrl: "", //文件链接
                status: type,
              };
            } else {
              value = {
                templateId: this.id,
                superviseFlag: 0, //督办标识 0.不是 1.是
                templateType: this.templateType, //模板类型
                templateContent: JSON.stringify(data), //文件内容
                templateName: workbook_name, //模板名称
                templateUrl: "", //文件链接
                status: type,
              };
            }

            await this.$http({
              url: "/market/CMKFileTemplate/UptateCMKFileTemplateById", //
              method: "post",
              headers: {
                "Content-Type": "application/json",
              },
              data: value,
            });
            this.$emit("save");
            return;
          }
          // 员工提交
          this.rowList.shift();
          let reqdata = {
            rowIndex: [...new Set(this.rowList)]
              .sort(function (a, b) {
                return a - b;
              })
              .join(","),
            rowContent: [...new Set(this.rowList)]
              .sort(function (a, b) {
                return a - b;
              })
              .map((el) => {
                return data.data[el];
              }),
          };
          await this.$http({
            url: edit_url, //提交
            method: "post",
            headers: {
              "Content-Type": "application/json",
            },
            data: {
              id: this.template_id,
              templateContent: JSON.stringify(data),
              templateName: workbook_name,
              issuedId: this.issued_id,
              rowJson: JSON.stringify(reqdata),
            },
          });
          this.$emit("save");
        }
      }
    },
    // 判断数组是否有值
    confirmArrayData(data) {
      if (data instanceof Array) {
        let flag = 0;
        if (data.length) {
          data.forEach((el) => {
            if (el instanceof Object) {
              flag = flag + 1;
            }
          });
          if (flag) {
            return true;
          } else {
            return false;
          }
        } else {
          return false;
        }
      } else {
        return false;
      }
    },
    async handleAuth() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.handleForbid()) {
            this.$message.error("请完善可编辑信息");
            return false;
          }
          if (this.id) {
            this.handleAddAuth({ id: this.id });
          }
          this.handleVisible();
        }
      });
    },
    // 通用方法用于转化全局
    paramsArr(start, end) {
      const arr = [];
      console.log(start, end);
      for (let i = Number(start); i <= Number(end); i++) {
        arr.push(i);
      }
      return arr.join(",");
    },
    filterName(id, arr) {
      return arr.filter((el) => el.secLeaderLogin === id)[0].secLeaderName;
    },
    handleCharge(type) {
      switch (type) {
        case "add":
          this.form.charge.push({
            person: "",
          });
          this.handleForbid();
          break;
        case "delete":
          this.form.charge.pop();
          this.handleForbid();
          break;
      }
    },
    handleVisible() {
      this.visible = !this.visible;
    },
    handleInput(index, name, value) {
      let reg = /^[0-9]*$/;
      if (!reg.test(value)) {
        this.form.charge[index][name] = this.form.charge[index][name].substr(
          0,
          this.form.charge[index][name].length - 1
        );
        this.$message.error("该处只能填写数字");
      }
    },
    async handleApprove(type) {
      if (type) {
        if (this.approveForm.type) {
          if (this.approveForm.type === "3" && !this.approveForm.comments) {
            this.$message.error("请输入其他审批意见");
            return;
          }
        } else {
          this.$message.error("请选择审批意见");
          return;
        }
        const sheet_name = window.luckysheet.getSheet().name;
        const data = window.luckysheet.getSheet(sheet_name);
        const workbook_name = window.luckysheet.getWorkbookName();
        // 经理提交
        this.rowList.shift();
        let reqdata = {
          rowIndex: [...new Set(this.rowList)]
            .sort(function (a, b) {
              return a - b;
            })
            .join(","),
          rowContent: [...new Set(this.rowList)]
            .sort(function (a, b) {
              return a - b;
            })
            .map((el) => {
              return data.data[el];
            }),
        };
        await this.$http({
          url: "/market/CMKIssued/CMKIssuedSubmit", // 提交
          method: "post",
          headers: {
            "Content-Type": "application/json",
          },
          data: {
            id: this.template_id,
            templateContent: JSON.stringify(data),
            templateName: workbook_name,
            issuedId: this.issued_id,
            rowJson: JSON.stringify(reqdata),
          },
        });
        let params = {
          id: this.issued_id,
          reviewOpinion:
            this.approveForm.type === "3"
              ? this.approveForm.comments
              : this.approveForm.type,
        };
        switch (type) {
          case "1":
            params = {
              ...params,
              operateName: "结束",
              status: 3,
            };
            break;
          case "4":
            params = {
              ...params,
              operateName: "转副总审批",
              reviewType: 2,
            };
            break;
          case "3":
            params = {
              ...params,
              operateName: "转总经理审批",
              reviewType: 3,
            };
            break;
        }
        await this.$http({
          url: "/market/CMKIssued/CMKIssuedCheck", // 审批
          method: "post",
          headers: {
            "Content-Type": "application/json",
          },
          data: params,
        });
        this.$message({
          type: "success",
          message: "审批成功",
        });
        this.manager_approve = false;
        this.$emit("save");
      } else {
        this.manager_approve = false;
      }
    },
    handleFullscreen() {
      const element = document.body;
      const is_fullscreen =
        document.fullScreen ||
        document.mozFullScreen ||
        document.webkitIsFullScreen;
      if (!is_fullscreen) {
        //进入全屏,多重短路表达式
        (element.requestFullscreen && element.requestFullscreen()) ||
          (element.mozRequestFullScreen && element.mozRequestFullScreen()) ||
          (element.webkitRequestFullscreen &&
            element.webkitRequestFullscreen()) ||
          (element.msRequestFullscreen && element.msRequestFullscreen());
      } else {
        //退出全屏,三目运算符
        document.exitFullscreen
          ? document.exitFullscreen()
          : document.mozCancelFullScreen
          ? document.mozCancelFullScreen()
          : document.webkitExitFullscreen
          ? document.webkitExitFullscreen()
          : "";
      }
    },
    handleResave() {
      const sheet_name = window.luckysheet.getSheet().name;
      let baseUrl = "";
      const datas = window.luckysheet.getSheet(sheet_name);
      // switch (datas.subScript) {
      //   case 0:
      //     baseUrl = "expensesUnicom";
      //     break;
      //   case 1:
      //     baseUrl = "questionnaireUnicom";
      //     break;
      //   case 2:
      //     baseUrl = "expensesTelecom";
      //     datas.index = 2;
      //     break;
      //   case 3:
      //     baseUrl = "questionnaireTelecom";
      // }
         switch (datas.name) {
        case "联通资费内容":
        // case "双鸭山联通资费内容":
        // case "牡丹江联通资费内容":
        // case "鸡西联通资费内容":
        // case "齐齐哈尔联通资费内容":
        // case "鹤岗联通资费内容":
        // case "伊春联通资费内容":
        // case "哈尔滨联通资费内容":
        // case "大庆联通资费内容":
        // case "绥化联通资费内容":
        // case "大兴安岭联通资费内容":
        // case "黑河联通资费内容":
        // case "佳木斯联通资费内容":
          baseUrl = "expensesUnicom";
          datas.index = 0;
          datas.subScript = 0;
          break;
        case "联通问卷内容":
          baseUrl = "questionnaireUnicom";
          datas.index = 1;
          datas.subScript = 1;
          break;
        // case "七台河电信资费内容":
        // case "双鸭山电信资费内容":
        // case "牡丹江电信资费内容":
        // case "鸡西电信资费内容":
        // case "齐齐哈尔电信资费内容":
        // case "鹤岗电信资费内容":
        // case "伊春电信资费内容":
        // case "哈尔滨电信资费内容":
        // case "大庆电信资费内容":
        // case "绥化电信资费内容":
        // case "大兴安岭电信资费内容":
        // case "黑河电信资费内容":
        case "电信资费内容":
          baseUrl = "expensesTelecom";
          datas.index = 0;
          datas.subScript = 0;
          break;
        case "电信问卷内容":
          baseUrl = "questionnaireTelecom";
          datas.index = 1;
          datas.subScript = 1;
      }
      const workbook_name = window.luckysheet.getWorkbookName();
      let value = {};
      if (
        Object.values(this.superviseForm).filter((el) => el !== "").length === 3
      ) {
        value = {
          templateId: this.id,
          distributeEndTime: this.superviseForm.endTime, // 督办设置的截止时间
          distributeTime: this.superviseForm.write, // 派发时间–或者叫—填报时间
          distributeType: this.superviseForm.distribute, //派发周期类型 派发周期类型 0.月 1.季度 2.半年 3.年
          superviseFlag: 1, //督办标识 0.不是 1.是
          templateType: this.templateType, //模板类型
          mKcompetitor: JSON.parse(datas), //文件内容
          templateName: workbook_name, //模板名称
          templateUrl: "", //文件链接
          status: "0",
        };
      } else {
        let data = datas;
        // data.id = this.id;
        // data.fileName = window.luckysheet.getWorkbookName();
        // data.powerFlag = 1;
        // data.powerFlagDev = "关";
        // data.tempType = this.templateType;
        // data.colHeaderNum = 1;
        // data.tempTypeDesc = "";
        value = {
          // templateId: this.id,
          // superviseFlag: 0, //督办标识 0.不是 1.是
          // templateType: this.templateType, //模板类型
          data: data, //文件内容
          // templateName: workbook_name, //模板名称
          // templateUrl: "", //文件链接
          // status: "0",
        };
      }
      this.$http({
        // 联通资费内容
        // url: "/market/expensesUnicom/save",
        //联通问卷
        //  url: "/market/questionnaireUnicom/save",
        //电信费用
        // url: "/market/expensesTelecom/save",
        //电信问卷
        //  url: "/market/questionnaireTelecom/save",
        url: "/market/" + baseUrl + "/save",
        method: "post",
        headers: {
          "Content-Type": "application/json",
        },
        data: value,
      }).then(() => {
        this.$message({
          type: "success",
          message: "保存成功",
        });
        this.getCheck();
      });
    },
    handleChargeList() {
      this.$http({
        url: "/market/techcentergj/queryLeaderList",
        method: "post",
        headers: {
          "Content-Type": "application/json",
        },
        data: {},
      }).then((response) => {
        this.charge_list = response.data.map((element) => ({
          label: `${element.ou} ${element.secLeaderName}`,
          value: `${element.ou}-${element.secLeaderLogin},${element.secLeaderName}`,
        }));
      });
    },
  },
  mounted() {
    this.getCheck();
    this.getJurisdiction();
    this.handleInit();
    // this.handleChargeList();
  },
  destroyed() {
    window.luckysheet.destroy();
  },
};
</script>

<style lang="scss" scope>
.el-dialog {
  width: 100%;
  height: 100%;
  margin-top: 0 !important;
}
.sheet-container {
  position: fixed;
  width: calc(100% - 40px);
  height: 100%;
  &-block {
    overflow: hidden;
    position: absolute;
    width: 100%;
    height: 75%;
  }
  &-require {
    color: red;
  }
  .el-input {
    width: 200px;
    margin-right: 10px;
  }
}
.form {
  &-input {
    margin-top: 5px;
    .el-input {
      width: 150px;
      .el-input__inner {
        height: 30px !important;
        line-height: 30px !important;
      }
    }
  }
  &-content {
    margin: 0px 10px;
  }
  &-select {
    .el-input {
      width: 100px;
      .el-input__inner {
        height: 30px !important;
        line-height: 30px !important;
      }
    }
  }
}
</style>

